package com.nationrel.modules.fta.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.nationrel.modules.fta.entity.FtaAnalysis;
import com.nationrel.modules.fta.entity.FtaAnalysisSetting;
import com.nationrel.modules.fta.general.common.ServerResponse;
import com.nationrel.modules.fta.general.domain.auth.HeaderUserInfo;
import com.nationrel.modules.fta.vo.FtaAnalysisTreeVo;
import com.nationrel.modules.fta.vo.FtaCircleParamTimeVo;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

public interface FtaAnalysisService extends IService<FtaAnalysis> {
    ServerResponse<List<FtaAnalysisTreeVo>> listByPage(HeaderUserInfo userInfo, String projectId);

    ServerResponse<FtaAnalysisTreeVo> addAnalysis(HeaderUserInfo userInfo, FtaAnalysis entity);

    ServerResponse<FtaAnalysisTreeVo> updateAnalysis(HeaderUserInfo userInfo, FtaAnalysis entity);

    ServerResponse<String> updateAnalysisName(HeaderUserInfo userInfo, FtaAnalysis entity);

    ServerResponse<String> deleteAnalysis(String analysisId, HeaderUserInfo headerUserInfo);

    ServerResponse<String> copyAnalysis(String analysisId, HeaderUserInfo headerUserInfo);

    ServerResponse<String> importAnalysis(String projectId, MultipartFile file, HeaderUserInfo headerUserInfo);

    void exportAnalysis(HttpServletResponse response, String analysisId, HeaderUserInfo headerUserInfo);

    ServerResponse<String> repairDiagramData(String analysisId, HeaderUserInfo headerUserInfo);

    ServerResponse<FtaAnalysisTreeVo> updateSetting(HeaderUserInfo userInfo, FtaAnalysisSetting setting);

    ServerResponse<List<String>> getCircleTimes(HeaderUserInfo userInfo, String analysisId);

    ServerResponse<String> saveCircleTimes(HeaderUserInfo userInfo, FtaCircleParamTimeVo vo);
}
